package rechnernetze;

import java.net.Socket;
import java.net.ServerSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

import java.io.IOException;
import java.io.BufferedReader;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;


public class Server {
  ServerSocket serversocket;

  public Server(int port) {
    System.out.println("Starte Server.");
    try {
      serversocket = new ServerSocket(port);
    } catch (IOException e) {}
    System.out.println("Server gestartet.");
    while (true) {
      empfangePackete();
    }
  }

  /** Empfaengt TCP-Pakete. */
  void empfangePackete() {
     try {
      // auf Clients warten
      Socket socket = serversocket.accept();
      socket.setReceiveBufferSize(1500);
      System.out.println("Verbindung!");

      // Verbindungsdaten merken
      InetAddress clientAdresse = socket.getInetAddress();
      int clientPort = socket.getPort();

      // Daten empfangen
      InputStream is = socket.getInputStream();
      InputStreamReader isr = new InputStreamReader(is);
      BufferedReader br = new BufferedReader(isr);

      String packet = br.readLine();

      // Verbingung schliessen
//      socket.close();

      // Wadde hadde dude da?
      System.out.println("Schnueffeln - Wadde hadde dudde da? : ");
      System.out.println("Client Adresse : " + clientAdresse.getHostAddress());
      System.out.println("Client Port    : " + clientPort);
      System.out.println(packet);

      // Daten zurueck schicken
      System.out.println("Oeffne TCP-Verbindung zu Client.");
//      socket = new Socket(clientAdresse, clientPort);
      OutputStream os = socket.getOutputStream();
      OutputStreamWriter osw = new OutputStreamWriter(os);
      PrintWriter pw = new PrintWriter(osw);
      pw.println(packet);
      pw.flush();
      socket.close();

      System.out.println(br.readLine());
    } catch (IOException e) {};
    System.out.println("Paket zurueckgeschickt.");

  }

  public static void main(String[] args) {
    System.out.println("Server [port].");
    System.out.println("--------------");
    Server server = new Server(Integer.parseInt(args[0]));
    server.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
} 