package rechnernetze;

import java.net.Socket;
import java.net.ServerSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

import java.io.IOException;
import java.io.BufferedReader;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;


public class Client_2 {
  int zielPort;
  int clientPort;
  InetAddress zielAdresse;
  ServerSocket serversocket;
  Socket socket;

  public Client_2(String iaddrString, int zielport) {
    System.out.println("Starte Client. - quit beendet Client.");
    this.zielPort = zielport;
    try {
      zielAdresse = InetAddress.getByName(iaddrString);
    } catch (UnknownHostException e) {}

    try {
       // Verbindung oeffnen
       System.out.println("Oeffne TCP-Verbindung zu Server.");
       socket = new Socket(zielAdresse, zielPort);
    } catch (IOException e) {System.out.println("Oeffnen Fehlgeschlagen");}


    System.out.println("Client gestartet.");
    start();
  }

  private void start() {
    String zeile = "";
    while (!zeile.equals("quit")) {
      System.out.print("Bitte eine neue Zeile eingeben : ");
      zeile = liesZeile();
      System.out.println("Sende Zeile zu Server");
      if (!zeile.equals("quit")) {
        sendePacket(zeile);
      }
    }
//    try {
//      socket.close();
//    } catch (IOException e) {}
  }

  /** Sendet ein Packet an den Server. */
  private void sendePacket(String zeile) {
    try {
//    socket = new Socket(zielAdresse, zielPort);
      OutputStream os = socket.getOutputStream();
      OutputStreamWriter osw = new OutputStreamWriter(os);
      PrintWriter pw = new PrintWriter(osw);
      // senden
      pw.println(zeile);
      pw.flush();

      System.out.println("Warte auf Server Antwort.");
      
      // Antwort empfangen
      InputStream is = socket.getInputStream();
      InputStreamReader isr = new InputStreamReader(is);
      BufferedReader br = new BufferedReader(isr);
      System.out.println("Antwort : "+br.readLine());


      System.out.println("Antwort empfangen.\n\n");
    } catch (IOException e) {
      System.err.println("######## Fehler bei der Uebertragung! ########");
    }
  }

  /** Liesst eine Zeile von der Tastatur. */
  private String liesZeile() {
    StringBuffer b = new StringBuffer();;
    int keyInput;
    try {
      while ((keyInput = System.in.read()) != 10) {
        b.append((char)keyInput);
      }
    } catch (IOException e) {};
    return b.toString();
  }

  public static void main(String[] args) {

    System.out.println("Client [serveradresse] [serverport].");
    System.out.println("-------------------------------------------");
    Client_2 client = new Client_2(args[0], Integer.parseInt(args[1]));
    client.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
}